import 'dart:async';
import 'dart:ui';

class Debouncer {
  final Duration duration;
  Timer? _timer;

  Debouncer({this.duration = const Duration(milliseconds: 500)});

  void run(VoidCallback action) {
    if (_timer?.isActive ?? false) return;
    action();
    _timer = Timer(duration, () {});
  }

  void dispose() {
    _timer?.cancel();
  }
}